VERSION 5.00
Begin VB.Form FrmAlphaPixels 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Alpha Pixels"
   ClientHeight    =   5775
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   8040
   Icon            =   "FrmAlphaPixels.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5775
   ScaleWidth      =   8040
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox Picture3 
      BorderStyle     =   0  'None
      Enabled         =   0   'False
      Height          =   240
      Left            =   7635
      Picture         =   "FrmAlphaPixels.frx":000C
      ScaleHeight     =   240
      ScaleWidth      =   240
      TabIndex        =   10
      Top             =   4630
      Width           =   240
   End
   Begin VB.CommandButton CmdDropper 
      Caption         =   "."
      Enabled         =   0   'False
      Height          =   375
      Left            =   7560
      MouseIcon       =   "FrmAlphaPixels.frx":008D
      TabIndex        =   9
      Top             =   4560
      Width           =   375
   End
   Begin VB.PictureBox PicBackColor 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      Enabled         =   0   'False
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   5940
      ScaleHeight     =   225
      ScaleWidth      =   585
      TabIndex        =   7
      Top             =   4620
      Width           =   615
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Don't display this window again and make always this desition."
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   5160
      Width           =   3735
   End
   Begin VB.CommandButton CmdAccept 
      Caption         =   "Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   6600
      TabIndex        =   5
      Top             =   5280
      Width           =   1335
   End
   Begin VB.CommandButton CmdBackColor 
      Caption         =   "             BackColor"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5880
      TabIndex        =   4
      Top             =   4560
      Width           =   1575
   End
   Begin VB.OptionButton OptPreserve 
      Caption         =   "Preserve Alpha Pixel"
      Height          =   195
      Left            =   4080
      TabIndex        =   3
      Top             =   4560
      Width           =   1815
   End
   Begin VB.OptionButton OptRemove 
      Caption         =   "Remove Alpha Pixel"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   4560
      Value           =   -1  'True
      Width           =   1815
   End
   Begin VB.PictureBox Picture2 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   4080
      ScaleHeight     =   3840
      ScaleWidth      =   3840
      TabIndex        =   1
      Top             =   600
      Width           =   3840
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   120
      ScaleHeight     =   3840
      ScaleWidth      =   3840
      TabIndex        =   0
      Top             =   600
      Width           =   3840
   End
   Begin VB.Label Label1 
      Caption         =   "This image contains transparent pixels, this resolution should not preserve them, or make a background color"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   7815
   End
End
Attribute VB_Name = "FrmAlphaPixels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Declare Function TransparentBlt Lib "msimg32.dll" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Long
Private WithEvents FrmCPicker As FrmColorPicker
Attribute FrmCPicker.VB_VarHelpID = -1
Private cDIB32Remove As c32bppDIB
Private cDIB32Preseve As c32bppDIB
Private cDIB As ClsDIB
Public m_BackColor As OLE_COLOR

Private Sub CmdAccept_Click()
    Me.Visible = False
End Sub

Private Sub CmdBackColor_Click()
    If FrmCPicker Is Nothing Then
        Set FrmCPicker = New FrmColorPicker
        FrmCPicker.PopUpColor Me, CmdBackColor.Left, CmdBackColor.Top + CmdBackColor.Height, Me.ColorBack
    End If
End Sub

Private Sub CmdDropper_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    CmdDropper.MousePointer = vbCustom
End Sub

Private Sub CmdDropper_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim PT As POINTAPI
    Dim DeskDC As Long
    GetCursorPos PT
    DeskDC = GetDC(0)
    Me.ColorBack = GetPixel(DeskDC, PT.X, PT.Y)
    ReleaseDC 0&, DeskDC
    CmdDropper.MousePointer = vbDefault
    DrawPreserveAlpha
End Sub

Private Sub Form_Activate()
    Set FrmCPicker = Nothing
End Sub

Public Property Get ColorBack() As OLE_COLOR
    ColorBack = m_BackColor
End Property

Public Property Let SetDIB(ByVal TheDIB32 As c32bppDIB)
    
    TheDIB32.CopyImageTo cDIB32Preseve
    TheDIB32.CopyImageTo cDIB32Remove
    
    cDIB32Remove.RemoveAlpha
    cDIB32Remove.Render Picture1.hdc, 128 - cDIB32Remove.Width / 2, 128 - cDIB32Remove.Height / 2
    Picture1.Refresh
    
    cDIB.Create cDIB32Preseve.Width, cDIB32Preseve.Height, [24_bpp]
    DrawPreserveAlpha
    
    
    
End Property



Public Property Let ColorBack(ByVal NewColor As OLE_COLOR)
    m_BackColor = NewColor
    PicBackColor.BackColor = NewColor
End Property

Private Sub Form_Load()
    Dim i As Long, j As Long, X As Long
    Set cDIB32Remove = New c32bppDIB
    Set cDIB32Preseve = New c32bppDIB
    Set cDIB = New ClsDIB
    
    With Picture1
        .ScaleMode = vbPixels
        .AutoRedraw = True
    
        For j = -1 To .ScaleHeight Step 6
            X = IIf(X = -1, 5, -1)
            For i = X To .ScaleWidth Step 12
                Picture1.Line (i, j)-(i + 5, j + 5), &HCCCCCC, BF
            Next
        Next
        
        Picture1.Line (0, 0)-(Picture1.ScaleWidth - 1, Picture1.ScaleWidth - 1), &HC0C0C0, B
        .Picture = .Image
    End With
    
    Picture2.Picture = Picture1.Image
End Sub

Private Sub FrmCPicker_SelectColor(ByVal NewColor As stdole.OLE_COLOR)
    m_BackColor = NewColor
    PicBackColor.BackColor = NewColor
    Call DrawPreserveAlpha
End Sub

Private Sub DrawPreserveAlpha()
    Picture2.Cls
    cDIB.Fill Me.ColorBack
    cDIB32Preseve.Render cDIB.hdc
    TransparentBlt Picture2.hdc, 128 - cDIB.Width / 2, 128 - cDIB.Height / 2, cDIB.Width, cDIB.Height, cDIB.hdc, 0, 0, cDIB.Width, cDIB.Height, Me.ColorBack
    Picture2.Refresh
End Sub


Private Sub OptPreserve_Click()
    CmdBackColor.Enabled = True
    CmdDropper.Enabled = True
End Sub

Private Sub OptRemove_Click()
    CmdBackColor.Enabled = False
    CmdDropper.Enabled = False
End Sub
