VERSION 5.00
Begin VB.Form FrmColorPicker 
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   2490
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1980
   LinkTopic       =   "Form1"
   MouseIcon       =   "FrmColorPicker.frx":0000
   ScaleHeight     =   2490
   ScaleWidth      =   1980
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Shape Shape1 
      DrawMode        =   2  'Blackness
      Height          =   240
      Left            =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   240
   End
End
Attribute VB_Name = "FrmColorPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Sub SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long)
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Private Const GWL_EXSTYLE As Long = -20
Private Const WS_EX_TOPMOST As Long = &H8&
Private Const HWND_TOPMOST      As Long = -1
Private Const HWND_NOTOPMOST    As Long = -2
Private Const SWP_NOSIZE        As Long = &H1
Private Const SWP_NOMOVE        As Long = &H2
Private Const SWP_NOACTIVATE    As Long = &H10
Private Const SWP_SHOWWINDOW    As Long = &H40

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Const COLOR_BACK As Long = &HFEFEFE
Private Const COLOR_BORDER As Long = &HC56A31

Public Event SelectColor(ByVal NewColor As OLE_COLOR)
Private Sub Form_Deactivate()
    Unload Me
End Sub

Public Sub PopUpColor(ByVal FrmOwner As Form, ByVal xLeft As Single, ByVal yTop As Single, ByVal DefaultColor As OLE_COLOR)
    Dim i As Long, x As Long, y As Long
    Dim PT As POINTAPI
    
    ClientToScreen FrmOwner.hwnd, PT

    With Me
        .ScaleMode = vbPixels
        .AutoRedraw = True
        .FillColor = COLOR_BACK
        .FillStyle = vbSolid
        .Width = 85 * Screen.TwipsPerPixelX
        .Height = 108 * Screen.TwipsPerPixelY
        .MousePointer = vbCustom
        .Left = (PT.x * Screen.TwipsPerPixelX) + xLeft
        .Top = (PT.y * Screen.TwipsPerPixelY) + yTop
    End With

    Shape1.Width = 21
    Shape1.Height = 21

    Me.Line (0, 0)-(Me.ScaleWidth - 1, Me.ScaleHeight - 1), COLOR_BORDER, B
    Me.FillColor = DefaultColor
    Me.Line (4, 5)-(80, 22), COLOR_BORDER, B
    
    x = 4
    y = 27
    For i = 0 To 15
        Me.FillColor = QBColor(i)
        Me.Line (x, y)-(x + 16, y + 16), COLOR_BORDER, B
        x = x + 20
        If (i + 1) Mod 4 = 0 Then y = y + 20: x = 4
    Next
    
    Me.Show , FrmOwner
    
    If (GetWindowLong(FrmOwner.hwnd, GWL_EXSTYLE) And WS_EX_TOPMOST) = WS_EX_TOPMOST Then
        SetWindowPos Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOSIZE
    End If

End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim xColor As OLE_COLOR
    xColor = Me.Point(x, y)
    If xColor <> COLOR_BACK And xColor <> COLOR_BORDER And y > 24 Then
        Shape1.Visible = True
        Shape1.Move (x \ 20) * 20 + 2, (y \ 22) * 20 + 5
    Else
        Shape1.Visible = False
    End If

End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim xColor As OLE_COLOR
    xColor = Me.Point(x, y)
    If xColor <> COLOR_BACK And xColor <> COLOR_BORDER And y > 24 Then
        RaiseEvent SelectColor(xColor)
    End If

    Unload Me
End Sub

