Attribute VB_Name = "MdlInternet"
Option Explicit

Private Declare Function InternetOpen Lib "wininet" Alias "InternetOpenA" (ByVal sAgent As String, ByVal lAccessType As Long, ByVal sProxyName As String, ByVal sProxyBypass As String, ByVal lFlags As Long) As Long
Private Declare Function InternetOpenUrl Lib "wininet" Alias "InternetOpenUrlA" (ByVal hInternetSession As Long, ByVal lpszUrl As String, ByVal lpszHeaders As String, ByVal dwHeadersLength As Long, ByVal dwFlags As Long, ByVal dwContext As Long) As Long
Private Declare Function InternetReadFile Lib "wininet" (ByVal hFile As Long, ByVal sBuffer As String, ByVal lNumBytesToRead As Long, lNumberOfBytesRead As Long) As Integer
Private Declare Function InternetCloseHandle Lib "wininet" (ByVal hInet As Long) As Integer
Private Declare Function InternetGetConnectedState Lib "wininet.dll" (ByRef lpdwFlags As Long, ByVal dwReserved As Long) As Long
Private Declare Function HttpQueryInfo Lib "wininet.dll" Alias "HttpQueryInfoA" (ByVal hHttpRequest As Long, ByVal lInfoLevel As Long, ByRef sBuffer As Any, ByRef lBufferLength As Long, ByRef lIndex As Long) As Integer

Private Const IF_NO_CACHE_WRITE& = &H4000000
Private Const HTTP_QUERY_CONTENT_TYPE As Long = 1
Private Const HTTP_QUERY_STATUS_CODE As Long = 19
Private Const INTERNET_OPEN_TYPE_DIRECT = 1

Public Function DownloadImageToFile(ByVal sUrl As String, ByVal sDestPath As String) As Boolean
    On Error GoTo ErrHandle
    Dim hInternet As Long, hFile As Long, lngRead As Long
    Dim sBuffer As String * &H4D8
    Dim FF As Integer
        
    If InternetGetConnectedState(&H0, &H0) Then
        
        hInternet = InternetOpen(vbNullString, INTERNET_OPEN_TYPE_DIRECT, vbNullString, vbNullString, &H0)
        If hInternet Then
            hFile = InternetOpenUrl(hInternet, sUrl, vbNullString, &H0, &H0, &H0)
            
            If HttpQueryInfo(hFile, HTTP_QUERY_STATUS_CODE, ByVal sBuffer, Len(sBuffer), 0) Then
                If Left$(sBuffer, InStr(sBuffer, Chr$(0))) <> 200 Then
                    InternetCloseHandle hFile: hFile = 0
                Else
                    If HttpQueryInfo(hFile, HTTP_QUERY_CONTENT_TYPE, ByVal sBuffer, Len(sBuffer), 0) Then
                        If Left$(sBuffer, 5) <> "image" Then
                            InternetCloseHandle hFile: hFile = 0
                        End If
                    End If
                End If
            End If
                    
            If hFile Then
                If Dir(sDestPath) <> vbNullString Then Kill sDestPath
                FF = FreeFile
                Open sDestPath For Binary As #FF
                    Do
                        InternetReadFile hFile, sBuffer, &H4D8, lngRead
                        Put #FF, , Left$(sBuffer, lngRead)
                    Loop While lngRead
                Close #FF
                DownloadImageToFile = True
                InternetCloseHandle hFile
            End If
            InternetCloseHandle hInternet
        End If
    End If
ErrHandle:

End Function
