VERSION 5.00
Begin VB.Form FrmIconFromRes 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Load from PE Files"
   ClientHeight    =   5160
   ClientLeft      =   45
   ClientTop       =   480
   ClientWidth     =   6825
   Icon            =   "FrmIconFromRes.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5160
   ScaleWidth      =   6825
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.TextBox TxtResFile 
      Height          =   300
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   5
      Top             =   4110
      Width           =   5175
   End
   Begin VB.CommandButton CmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   5400
      TabIndex        =   4
      Top             =   4680
      Width           =   1335
   End
   Begin VB.CommandButton CmdAceptar 
      Caption         =   "Acept"
      Default         =   -1  'True
      Height          =   375
      Left            =   3960
      TabIndex        =   3
      Top             =   4680
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open"
      Height          =   375
      Left            =   5400
      TabIndex        =   2
      Top             =   4080
      Width           =   1335
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   2880
      ScaleHeight     =   3840
      ScaleWidth      =   3840
      TabIndex        =   1
      Top             =   120
      Width           =   3840
   End
   Begin VB.ListBox lbIcon 
      Height          =   3765
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2655
   End
   Begin VB.Line Line2 
      BorderColor     =   &H80000016&
      X1              =   120
      X2              =   6720
      Y1              =   4575
      Y2              =   4575
   End
   Begin VB.Line Line1 
      BorderColor     =   &H80000010&
      X1              =   120
      X2              =   6720
      Y1              =   4560
      Y2              =   4560
   End
End
Attribute VB_Name = "FrmIconFromRes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function DrawIconEx Lib "user32.dll" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function CreateIconFromResourceEx Lib "user32.dll" (ByRef presbits As Any, ByVal dwResSize As Long, ByVal fIcon As Long, ByVal dwVer As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal Flags As Long) As Long
Private Declare Function PickIconDlg Lib "shell32.dll" Alias "#62" (ByVal hwndOwner As Long, ByVal lpstrFile As String, ByVal nMaxFile As Long, lpdwiIndex As Long) As Long
Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long

Private Const ICONVERSION               As Long = &H30000
Private Const LR_DEFAULTCOLOR           As Long = &H0
Private Const LOAD_LIBRARY_AS_DATAFILE  As Long = &H2&

Private Const DI_MASK = &H1
Private Const DI_IMAGE = &H2
Private Const DI_NORMAL = DI_MASK Or DI_IMAGE

Private Type ICONDIR
   idReserved           As Integer              '// Reserved
   idType               As Integer              '// resource type (1 for icons)
   idCount              As Integer              '// how many images?
   'idEntries()         as ICONDIRENTRY         '//array follows.
End Type

Private Type ICONDIRENTRY
   bWidth               As Byte                 '// Width of the image
   bHeight              As Byte                 '// Height of the image (times 2)
   bColorCount          As Byte                 '// Number of colors in image (0 if >=8bpp)
   bReserved            As Byte                 '// Reserved
   wPlanes              As Integer              '// Color Planes
   wBitCount            As Integer              '// Bits per pixel
   dwBytesInRes         As Long                 '// how many bytes in this resource?
   dwImageOffset        As Long                 '// where in the file is this image
End Type

Private Type MEMICONDIRENTRY
   bWidth               As Byte                 '// Width of the image
   bHeight              As Byte                 '// Height of the image (times 2)
   bColorCount          As Byte                 '// Number of colors in image (0 if >=8bpp)
   bReserved            As Byte                 '// Reserved
   wPlanes              As Integer              '// Color Planes
   wBitCount            As Integer              '// Bits per pixel
   dwBytesInRes         As Long                 '// how many bytes in this resource?
   nID                  As Integer              '// the ID
End Type

Private Type tBits
   bBits() As Byte
End Type


Private m_tIconHeader   As ICONDIR
Private m_tIconEntry()  As ICONDIRENTRY
Private m_tBits()       As tBits
Private ArrResource()   As String
Public cDIB As c32bppDIB



Private Sub CmdAceptar_Click()
    On Error GoTo ErrHandler
    Dim Index As Long
    Dim bArray() As Byte
    Set cDIB = New c32bppDIB
    
    Index = lbIcon.ListIndex
    
    If Index > -1 Then
        m_tIconHeader.idCount = 1
        m_tIconEntry(Index).dwImageOffset = Len(m_tIconHeader) + Len(m_tIconEntry(Index))
       
        ReDim bArray(m_tIconEntry(Index).dwImageOffset + UBound(m_tBits(Index).bBits))
       
        CopyMemory bArray(0), m_tIconHeader, Len(m_tIconHeader)
        CopyMemory bArray(Len(m_tIconHeader)), m_tIconEntry(Index), Len(m_tIconEntry(Index))
        CopyMemory bArray(m_tIconEntry(Index).dwImageOffset), m_tBits(Index).bBits(0), UBound(m_tBits(Index).bBits) + 1
             
        If cDIB.LoadPicture_Stream(bArray) Then
            Me.Tag = 1
            Me.Visible = False
        End If
       
    End If
    
    Exit Sub
    
ErrHandler:
    MsgBox "Error: " & Err.Number & vbCrLf & Err.Description
    
    
End Sub

Private Sub CmdCancel_Click()
    Me.Visible = False
End Sub

Private Sub Command1_Click()
    Dim sFile As String
    Dim iIndex As Long
    Dim sLen As Long
    Dim hIcon As Long
    Dim RetVal As Long

    sFile = m_PathRes & String(256, 0)
    sFile = StrConv(sFile, vbUnicode)
    RetVal = PickIconDlg(Me.hWnd, sFile, Len(sFile), iIndex)
    sFile = StrConv(sFile, vbFromUnicode)
    sFile = Left(sFile, InStr(sFile, vbNullChar) - 1)
    
    If RetVal <> 0 Then
        m_PathRes = sFile
        TxtResFile.Text = m_PathRes
        If LCase$(Right$(sFile, 3)) = "ico" Then
            If LoadIconFromFile(sFile) Then
                EnumereIcon
                DoEvents
                lbIcon_Click
            Else
                MsgBox "Error reading file", vbInformation
                Me.Visible = False
            End If
        Else
            If LoadIconFromResource(sFile, iIndex) Then
                EnumereIcon
                DoEvents
                lbIcon_Click
            Else
                MsgBox "Error reading resource", vbInformation
                Me.Visible = False
            End If
        End If
    End If
End Sub

Private Function DrawIcon(ByVal Index As Long) As Boolean
    Dim hIcon As Long
    Dim lLeft As Long, lTop As Long
    Dim lWidth As Long, lHeight As Long
    
    
    hIcon = CreateIconFromResourceEx(m_tBits(Index).bBits(0), m_tIconEntry(Index).dwBytesInRes, 1, ICONVERSION, m_tIconEntry(Index).bWidth, m_tIconEntry(Index).bHeight, LR_DEFAULTCOLOR)

    Picture1.Cls
    If hIcon <> 0 Then
          
        If m_tIconEntry(Index).bWidth = 0 And m_tIconEntry(Index).bHeight = 0 Then
            lWidth = 256
            lHeight = 256
        Else
            lWidth = m_tIconEntry(Index).bWidth
            lHeight = m_tIconEntry(Index).bHeight
        End If

        With Picture1
            lLeft = (.ScaleWidth / 2) - (lWidth / 2)
            lTop = (.ScaleHeight / 2) - (lHeight / 2)
            DrawIconEx .hdc, lLeft, lTop, hIcon, lWidth, lHeight, 0, 0, DI_NORMAL
            .Refresh
        End With
        
        DestroyIcon hIcon
    End If
End Function

Public Function IsPNG(ByRef bFirst8BytesArr() As Byte) As Boolean
    Dim szFirst8Bytes As String, i As Integer
    
    ' Figure out if this is an icon or a PNG by checking
    ' the first 8 byte for the PNG file signature
    szFirst8Bytes = ""
    For i = 0 To 7 Step 1
        If (i > UBound(bFirst8BytesArr)) Then Exit For
        szFirst8Bytes = szFirst8Bytes + Right("00" & Hex(bFirst8BytesArr(i)), 2)
    Next i
    IsPNG = (UCase(szFirst8Bytes) = "89504E470D0A1A0A")
End Function

'Thanks to Frank Schler or ActiveVB
Public Function LoadIconFromResource(ByVal sFile As String, Optional ByVal lpID As Long = 0, Optional ByVal lpName As String = "") As Boolean
    Dim hLibrary As Long
    Dim hRsrc As Long
    Dim hGlobal As Long
    Dim lPtr As Long
    Dim iEntry As Long
    Dim tMIDE As MEMICONDIRENTRY
    Dim nID() As Integer
    Dim iBaseOffset As Long
    Dim lSize As Long
    Dim bFail As Boolean

   ' Loads an Icon from an Executable (EXE, DLL etc).  Use the EnumResources module
   ' to determine the available resource IDs.

   Erase m_tIconEntry
   Erase m_tBits
   'ReDim ArrResource(0)
   Set CollResource = New Collection
   
   With m_tIconHeader
      .idCount = 0
      .idReserved = 0
      .idType = 0
   End With

   hLibrary = LoadLibraryEx(sFile, ByVal 0&, LOAD_LIBRARY_AS_DATAFILE)

   If (hLibrary = 0) Then
      ' Failed to load the executable. Probably not a Win32 EXE.
      'Err.Raise vbObjectError + 1048 + 6, App.EXEName & ".cFileIcon", "Can't load library."
      LoadIconFromResource = False
   Else
   
      Call EnumResourceNames(hLibrary, RT_GROUP_ICON, AddressOf EnumResNameProc, 0)

      lpName = CollResource.Item(lpID + 1)
    
      hRsrc = FindResource(hLibrary, ByVal lpName, ByVal RT_GROUP_ICON)

      If (hRsrc = 0) Then
         ' Resource not found in this library:
         'Err.Raise vbObjectError + 1048 + 7, App.EXEName & ".cFileIcon", "Can't find resource."
         LoadIconFromResource = False
      Else
         ' Load the resource (returns a handle which can be used to access the data):
         hGlobal = LoadResource(hLibrary, hRsrc)
         If (hGlobal = 0) Then
            'Err.Raise vbObjectError + 1048 + 8, App.EXEName & ".cFileIcon", "Can't load resource."
            LoadIconFromResource = False
         Else
            ' Lock the resource for reading (returns a pointer to the resource data):
            lPtr = LockResource(hGlobal)
            If (lPtr = 0) Then
               'Err.Raise vbObjectError + 1048 + 8, App.EXEName & ".cFileIcon", "Can't lock resource."
               LoadIconFromResource = False
            Else
               ' Get the icon header:
               CopyMemory m_tIconHeader, ByVal lPtr, Len(m_tIconHeader)
               
               ' Do we have icons in this resource?
               If (m_tIconHeader.idCount > 0) Then
                  
                  ' For each of the entries, get the icon directory information:
                  ReDim m_tIconEntry(0 To m_tIconHeader.idCount - 1) As ICONDIRENTRY
                  ReDim nID(0 To m_tIconHeader.idCount - 1) As Integer
                  
                  ' Get all the directory information into a byte array (to avoid
                  ' problems with WORD alignment of structures):
                  ReDim B(0 To Len(m_tIconHeader) + Len(tMIDE) * m_tIconHeader.idCount - 1) As Byte
                  CopyMemory B(0), ByVal lPtr, Len(m_tIconHeader) + Len(tMIDE) * m_tIconHeader.idCount
                  
                  ' Loop through the entries, getting the IDs and creating a standard
                  ' ICONDIRENTRY structure:
                  For iEntry = 0 To m_tIconHeader.idCount - 1
                     ' Get the MEMICONDIRENTRY structure:
                     CopyMemory tMIDE, B(Len(m_tIconHeader) + iEntry * Len(tMIDE)), Len(tMIDE)
                     ' Store the icon's resource id:
                     nID(iEntry) = tMIDE.nID
                     ' Copy data into standard ICONDIRENTRY structure.  Note the .dwImageOffset
                     ' member will be wrong at this stage:
                     CopyMemory m_tIconEntry(iEntry), tMIDE, Len(tMIDE)
                  Next iEntry
                  
                  ' Now correct the ICONDIRENTRY byte offsets:
                  iBaseOffset = Len(m_tIconHeader) + Len(m_tIconEntry(0)) * m_tIconHeader.idCount
                  m_tIconEntry(0).dwImageOffset = iBaseOffset
                  For iEntry = 1 To m_tIconHeader.idCount - 1
                     m_tIconEntry(iEntry).dwImageOffset = m_tIconEntry(iEntry - 1).dwImageOffset + m_tIconEntry(iEntry - 1).dwBytesInRes
                  Next iEntry
                  
                  ' Now we have the ICONDIRENTRY structures, get the actual bits of the icons:
                  ReDim m_tBits(0 To m_tIconHeader.idCount - 1) As tBits
                  For iEntry = 0 To m_tIconHeader.idCount - 1
                     ' Load the icon with the specified resource ID:
                     lpName = "#" & nID(iEntry)
                     hRsrc = FindResource(hLibrary, ByVal lpName, ByVal RT_ICON)
                     If (hRsrc = 0) Then
                        bFail = True
                        Exit For
                     Else
                        ' Load the resource:
                        hGlobal = LoadResource(hLibrary, hRsrc)
                        If (hGlobal = 0) Then
                           bFail = True
                           Exit For
                        Else
                           ' Determine the size of the resource:
                           lSize = SizeofResource(hLibrary, hRsrc)
                           ' If the size is valid:
                           If (lSize > 0) And (lSize = m_tIconEntry(iEntry).dwBytesInRes) Then
                              ' Lock the resource and get a pointer to the memory:
                              lPtr = LockResource(hGlobal)
                              If (lPtr = 0) Then
                                 bFail = True
                                 Exit For
                              Else
                                 ' Store this memory in the bitmap bits array:
                                 ReDim Preserve m_tBits(iEntry).bBits(0 To lSize - 1) As Byte
                                 CopyMemory m_tBits(iEntry).bBits(0), ByVal lPtr, lSize
                              End If
                           Else
                              bFail = True
                           End If
                        End If
                     End If
                  Next iEntry

                  ' Did we succeed?
                  If (bFail) Then
                     'Err.Raise vbObjectError + 1048 + 9, App.EXEName & ".cFileIcon", "Failed to read bitmap bits from resource."
                     ' ensure clear:
                     sFile = ""
                     Erase m_tIconEntry
                     Erase m_tBits
                     m_tIconHeader.idCount = 0
                  End If
                  LoadIconFromResource = Not (bFail)
                                       
               End If
               
            End If
         End If
      End If
      
      ' Free library:
      FreeLibrary hLibrary
      Set CollResource = Nothing
   End If
      
End Function


Public Function LoadIconFromFile(ByVal IcoFileName As String) As Boolean

    Dim bytIcoData() As Byte
    Dim FF As Long
    Dim i As Long
    
    If Dir(IcoFileName) <> "" Then
    
        If LCase$(Right$(IcoFileName, 3)) = "ico" Then
            Erase m_tIconEntry
            Erase m_tBits
            
            FF = FreeFile

            Open IcoFileName For Binary Access Read As #FF
                ReDim bytIcoData(LOF(FF) - 1)
                Get #FF, , bytIcoData()
            Close #FF
            
            Call CopyMemory(m_tIconHeader, bytIcoData(0), Len(m_tIconHeader))

            If m_tIconHeader.idType = 1 Then

                If m_tIconHeader.idCount >= 1 Then

                    ReDim m_tIconEntry(m_tIconHeader.idCount - 1)

                    Call CopyMemory(m_tIconEntry(0), bytIcoData(Len(m_tIconHeader)), Len(m_tIconEntry(0)) * m_tIconHeader.idCount)
                    
                    ReDim m_tBits(m_tIconHeader.idCount - 1)
                    
                    For i = 0 To m_tIconHeader.idCount - 1
                        ReDim m_tBits(i).bBits(m_tIconEntry(i).dwBytesInRes - 1)
                        Call CopyMemory(m_tBits(i).bBits(0), bytIcoData(m_tIconEntry(i).dwImageOffset), m_tIconEntry(i).dwBytesInRes)
                    Next

                    LoadIconFromFile = True
                    
                End If
            End If
        End If
    End If
    
End Function

Public Function IconColorDepth(ByVal Index As Long) As Long
    If m_tIconEntry(Index).wPlanes = 1 Then
        ' 16bit, 24bit, 32bit
        IconColorDepth = m_tIconEntry(Index).wBitCount
    Else
        ' 1bit, 4bit, 8bit
        Select Case m_tIconEntry(Index).bColorCount
            Case 2:     IconColorDepth = 1
            Case 16:    IconColorDepth = 4
            Case Else:  IconColorDepth = 8
        End Select
    End If
End Function

Private Sub Form_Load()
    
    Dim i As Long, j As Long, X As Long
    
    With Picture1
        .ScaleMode = vbPixels
        .AutoRedraw = True
    
        For j = -1 To .ScaleHeight Step 6
            X = IIf(X = -1, 5, -1)
            For i = X To .ScaleWidth Step 12
                Picture1.Line (i, j)-(i + 5, j + 5), &HCCCCCC, BF
            Next
        Next
        
        Picture1.Line (0, 0)-(Picture1.ScaleWidth - 1, Picture1.ScaleWidth - 1), vbHighlight, B
        .Picture = .Image
    End With

End Sub

Private Sub lbIcon_Click()
    Dim Index As Long
    Index = lbIcon.ListIndex
    
    If lbIcon.ListCount > 0 Then
        DrawIcon Index
    End If
End Sub

Private Sub EnumereIcon()

    Dim lngItem As Long
    Dim lWidth As Long
    Dim lHeight As Long
    Dim IsPNG_Value As String
    
    lbIcon.Clear
    
    For lngItem = 0 To m_tIconHeader.idCount - 1

        If m_tIconEntry(lngItem).bWidth = 0 And m_tIconEntry(lngItem).bHeight = 0 Then
            lWidth = 256
            lHeight = 256
            If IsPNG(m_tBits(lngItem).bBits) Then
                IsPNG_Value = " (PNG)"
            End If
        Else
            lWidth = m_tIconEntry(lngItem).bWidth
            lHeight = m_tIconEntry(lngItem).bHeight
            IsPNG_Value = vbNullString
        End If
        

        lbIcon.AddItem "Icon " & lngItem + 1 & ": " & lWidth & "x" & lHeight & "x" & IconColorDepth(lngItem) & "Bit" & IsPNG_Value
    Next lngItem
    
    lbIcon.SetFocus
    lbIcon.ListIndex = lbIcon.ListCount - 1
    
End Sub
