VERSION 5.00
Begin VB.Form FrmLoadFromRes 
   Caption         =   "Load From Resource"
   ClientHeight    =   6750
   ClientLeft      =   60
   ClientTop       =   585
   ClientWidth     =   9060
   Icon            =   "FrmLoadFromRes.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6750
   ScaleWidth      =   9060
   StartUpPosition =   1  'CenterOwner
   Begin VB.Frame FmeInfo 
      Caption         =   "Image Info"
      Height          =   3375
      Left            =   120
      TabIndex        =   5
      Top             =   2880
      Width           =   3015
      Begin VB.PictureBox PicMaskColor 
         Appearance      =   0  'Flat
         AutoRedraw      =   -1  'True
         AutoSize        =   -1  'True
         BackColor       =   &H00FF00FF&
         ForeColor       =   &H80000008&
         Height          =   300
         Left            =   1080
         MouseIcon       =   "FrmLoadFromRes.frx":038A
         MousePointer    =   99  'Custom
         ScaleHeight     =   270
         ScaleWidth      =   585
         TabIndex        =   16
         Top             =   2120
         Visible         =   0   'False
         Width           =   615
      End
      Begin VB.TextBox TxtSizeHeight 
         Height          =   300
         Left            =   1080
         TabIndex        =   13
         Top             =   2830
         Width           =   615
      End
      Begin VB.TextBox TxtSizeWidth 
         Height          =   300
         Left            =   1080
         TabIndex        =   12
         Top             =   2480
         Width           =   615
      End
      Begin VB.Label LblBpp 
         AutoSize        =   -1  'True
         Caption         =   "Bit per pixel:"
         Height          =   195
         Left            =   120
         TabIndex        =   15
         Top             =   1440
         Width           =   855
      End
      Begin VB.Label LblDimensions 
         AutoSize        =   -1  'True
         Caption         =   "Dimensions:"
         Height          =   195
         Left            =   120
         TabIndex        =   14
         Top             =   1080
         Width           =   855
      End
      Begin VB.Label Label4 
         AutoSize        =   -1  'True
         Caption         =   "Icon Height:"
         Height          =   195
         Left            =   120
         TabIndex        =   11
         Top             =   2880
         Width           =   870
      End
      Begin VB.Label Label3 
         AutoSize        =   -1  'True
         Caption         =   "Icon Width:"
         Height          =   195
         Left            =   120
         TabIndex        =   10
         Top             =   2520
         Width           =   825
      End
      Begin VB.Label LblMaskColor 
         AutoSize        =   -1  'True
         Caption         =   "Mask Color:   None"
         Height          =   195
         Left            =   120
         TabIndex        =   9
         Top             =   2160
         Width           =   1365
      End
      Begin VB.Label LblIcons 
         AutoSize        =   -1  'True
         Caption         =   "Icons:"
         Height          =   195
         Left            =   120
         TabIndex        =   8
         Top             =   1800
         Width           =   435
      End
      Begin VB.Label LblSize 
         AutoSize        =   -1  'True
         Caption         =   "Size:"
         Height          =   195
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Width           =   345
      End
      Begin VB.Label LblName 
         AutoSize        =   -1  'True
         Caption         =   "Name:"
         Height          =   195
         Left            =   120
         TabIndex        =   6
         Top             =   360
         Width           =   465
      End
   End
   Begin VB.Frame FmePreview 
      Caption         =   "Preview"
      Height          =   2775
      Left            =   3240
      TabIndex        =   3
      Top             =   0
      Width           =   5655
      Begin VB.PictureBox PicBitmap 
         AutoRedraw      =   -1  'True
         BorderStyle     =   0  'None
         Height          =   1095
         Left            =   120
         ScaleHeight     =   1095
         ScaleWidth      =   4695
         TabIndex        =   4
         Top             =   240
         Width           =   4695
      End
   End
   Begin VB.CommandButton CmdOk 
      Caption         =   "Ok"
      Default         =   -1  'True
      Height          =   375
      Left            =   6480
      TabIndex        =   2
      Top             =   6240
      Width           =   1215
   End
   Begin VB.CommandButton CmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   7800
      TabIndex        =   1
      Top             =   6240
      Width           =   1215
   End
   Begin VB.ListBox LstBitmaps 
      Height          =   2595
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "FrmLoadFromRes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function BitBlt Lib "gdi32.dll" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Const ErrTextBox = "The value must be greater than 0 and less than 256"
Private Const CLR_NONE  As Long = &HFFFFFFFF

Private sPath           As String
Private hModule         As Long
Private m_ResID         As String
Private m_hBitmap       As Long
Private m_Width         As Long
Private m_Height        As Long
Private m_ILC           As IMAGE_LIST_COLOR
Private m_MaskColor     As Long

Private Sub CmdCancel_Click()
    Me.Visible = False
End Sub

Private Sub CmdOk_Click()
    Me.Tag = 1
    Me.Visible = False
End Sub


Public Property Let Path(ByVal NewPath As String)
    Dim i As Long
    
    Set CollResource = New Collection

    sPath = NewPath
    Me.Caption = sPath

    hModule = LoadLibraryEx(sPath, 0, LOAD_LIBRARY_AS_DATAFILE)
    
    If hModule <> 0 Then
       
        EnumResourceNames hModule, RT_BITMAP, AddressOf EnumResNameProc, 0

        If CollResource.Count Then

            For i = 1 To CollResource.Count
            
                LstBitmaps.AddItem CollResource.Item(i)
                
            Next
            
            LstBitmaps.ListIndex = 0
        
        End If
       
    End If
End Property

Property Get ResID() As String
    ResID = m_ResID
End Property

Property Get BITMAP() As Long
    BITMAP = m_hBitmap
End Property

Property Get ColorDep() As IMAGE_LIST_COLOR
    ColorDep = m_ILC
End Property

Property Get IconWidth() As Long
    IconWidth = m_Width
End Property

Property Get IconHeight() As Long
    IconHeight = m_Height
End Property

Property Get MaskColor() As Long
    MaskColor = m_MaskColor
End Property



Private Sub Form_Activate()
    If CollResource.Count = 0 Then
        MsgBox "The file " & sPath & " don`t contain any Bitmap", vbInformation
        Me.Visible = False
    End If
End Sub

Private Sub Form_Resize()
    On Error Resume Next
    If Me.WindowState = vbMinimized Then Exit Sub
    If Me.ScaleHeight - FmeInfo.Height - 740 < 400 Then
        LstBitmaps.Height = Me.ScaleHeight - 700
        If FmeInfo.Visible = True Then FmeInfo.Visible = False
    Else
        LstBitmaps.Height = Me.ScaleHeight - FmeInfo.Height - 740
        FmeInfo.Top = Me.ScaleHeight - FmeInfo.Height - 640
        If FmeInfo.Visible = False Then FmeInfo.Visible = True
    End If
    FmePreview.Move FmePreview.Left, 0, Me.ScaleWidth - 3340, Me.ScaleHeight - 640
    CmdCancel.Move Me.ScaleWidth - 1350, Me.ScaleHeight - 530
    CmdOk.Move Me.ScaleWidth - 2700, Me.ScaleHeight - 530
End Sub

Private Sub LstBitmaps_Click()
    Dim hBitmap As Long
    
    Dim hGbl As Long
    Dim lPtr As Long
    Dim lSize As Long
    Dim hRes As Long
    Dim BIH As BITMAPINFOHEADER
    Dim hdc As Long
    Dim OldBMP As Long
    Dim NumIcon As Long
    
   
    m_ResID = LstBitmaps.List(LstBitmaps.ListIndex)
    
    If m_hBitmap <> 0 Then DeleteObject m_hBitmap
    
    m_hBitmap = LoadImage(hModule, m_ResID, IMAGE_BITMAP, 0, 0, LR_SHARED)
    
    If m_hBitmap = 0 Then
        MsgBox "Error to add file", vbInformation
        Exit Sub
    End If
    
    hRes = FindResource(hModule, ByVal m_ResID, ByVal CLng(RT_BITMAP))
    
    If Not hRes = 0 Then
        hGbl = LoadResource(hModule, hRes)
        If Not hGbl = 0 Then
           lSize = SizeofResource(hModule, hRes)
        
           If (lSize > LenB(BIH)) Then
              lPtr = LockResource(hGbl)
              CopyMemory BIH, ByVal lPtr, 40
           End If
        End If
        FreeResource hRes
    End If
    

    hdc = CreateCompatibleDC(0)
    OldBMP = SelectObject(hdc, m_hBitmap)
    PicBitmap.Cls
    PicBitmap.Width = BIH.biWidth * Screen.TwipsPerPixelX
    PicBitmap.Height = BIH.biHeight * Screen.TwipsPerPixelY
    
    
    m_ILC = BIH.biBitCount
    
    m_Width = (BIH.biWidth \ BIH.biHeight)
    If m_Width = 0 Then m_Width = 1
    m_Width = BIH.biWidth \ m_Width
    m_Height = BIH.biHeight
    
    BitBlt PicBitmap.hdc, 0, 0, BIH.biWidth, BIH.biHeight, hdc, 0, 0, vbSrcCopy
    PicBitmap.Refresh
    Call SelectObject(hdc, OldBMP)
    DeleteDC hdc

    NumIcon = BIH.biWidth \ m_Width
    
    If m_ILC <> ILC_COLOR32 Then
        m_MaskColor = GetMaskColor(m_hBitmap, m_Width, m_Height, NumIcon)
        If m_MaskColor = CLR_NONE Then m_MaskColor = vbMagenta
        PicMaskColor.BackColor = m_MaskColor
        PicMaskColor.Visible = True
        
    Else
        m_MaskColor = CLR_NONE
        PicMaskColor.Visible = False
    End If

    
    LblName.Caption = "Name: " & m_ResID
    LblSize.Caption = "Size: " & lSize
    LblDimensions.Caption = "Dimensions: " & BIH.biWidth & "x" & BIH.biHeight & " Pixels"
    LblBpp.Caption = "Colors: " & m_ILC & " Bpp"
    LblIcons.Caption = "Icons: " & NumIcon

    TxtSizeWidth.Text = BIH.biHeight
    TxtSizeHeight.Text = BIH.biHeight
End Sub

Private Sub PicMaskColor_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim pt As POINTAPI
    Dim DeskDC As Long
    GetCursorPos pt
    DeskDC = GetDC(0)
    m_MaskColor = GetPixel(DeskDC, pt.x, pt.y)
    ReleaseDC 0&, DeskDC
    PicMaskColor.BackColor = m_MaskColor
End Sub

Private Sub TxtSizeWidth_Validate(Cancel As Boolean)
    If IsNumeric(TxtSizeWidth) Then
        TxtSizeWidth = CInt(TxtSizeWidth)
        If TxtSizeWidth < 1 Or TxtSizeWidth > 256 Then
            MsgBox ErrTextBox
            Cancel = True
        Else
            m_Width = TxtSizeWidth
        End If
    Else
        MsgBox ErrTextBox
        Cancel = True
    End If
End Sub

Private Sub TxtSizeHeight_Validate(Cancel As Boolean)
    If IsNumeric(TxtSizeHeight) Then
        TxtSizeWidth = CInt(TxtSizeHeight)
        If TxtSizeHeight < 1 Or TxtSizeHeight > 256 Then
            MsgBox ErrTextBox
            Cancel = True
        Else
            m_Height = TxtSizeHeight
        End If
    Else
        MsgBox ErrTextBox
        Cancel = True
    End If
End Sub



Private Sub Form_Unload(Cancel As Integer)
    FreeLibrary hModule
    If m_hBitmap <> 0 Then DeleteObject m_hBitmap
End Sub

