VERSION 5.00
Begin VB.UserControl ucListIcon 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   ClientHeight    =   1455
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6810
   FillStyle       =   0  'Solid
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   1455
   ScaleWidth      =   6810
End
Attribute VB_Name = "ucListIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32.dll" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function GetProcAddress Lib "kernel32.dll" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Function VirtualAlloc Lib "kernel32.dll" (ByRef lpAddress As Long, ByVal dwSize As Long, ByVal flAllocationType As Long, ByVal flProtect As Long) As Long
Private Declare Function VirtualFree Lib "kernel32.dll" (ByRef lpAddress As Long, ByVal dwSize As Long, ByVal dwFreeType As Long) As Long
Private Declare Function SetScrollInfo Lib "user32" (ByVal hwnd As Long, ByVal n As Long, lpcScrollInfo As SCROLLINFO, ByVal bool As Boolean) As Long
Private Declare Function GetScrollInfo Lib "user32" (ByVal hwnd As Long, ByVal n As Long, lpScrollInfo As SCROLLINFO) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function ScrollWindowByNum& Lib "user32" Alias "ScrollWindow" (ByVal hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, ByVal lpRect As Long, ByVal lpClipRect As Long)
Private Declare Function GetWindowDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetWindowRect& Lib "user32" (ByVal hwnd As Long, lpRect As RECT)
Private Declare Function ExcludeClipRect Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DrawThemeBackGround Lib "uxtheme.dll" Alias "DrawThemeBackground" (ByVal hTheme As Long, ByVal lhdc As Long, ByVal iPartId As Long, ByVal iStateId As Long, pRect As RECT, pClipRect As RECT) As Long
Private Declare Function OpenThemeData Lib "uxtheme.dll" (ByVal hwnd As Long, ByVal pszClassList As Long) As Long
Private Declare Function CloseThemeData Lib "uxtheme.dll" (ByVal hTheme As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function GetFocus Lib "user32.dll" () As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function IsChild Lib "user32.dll" (ByVal hWndParent As Long, ByVal hwnd As Long) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function ClientToScreen Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Private Declare Function SetCursor Lib "user32.dll" (ByVal hCursor As Long) As Long
Private Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl As Long, ByVal i As Long, ByVal hdcDst As Long, ByVal x As Long, ByVal y As Long, ByVal fStyle As Long) As Long
Private Declare Function ImageList_GetIconSize Lib "comctl32.dll" (ByVal himl As Long, ByRef cx As Long, ByRef cy As Long) As Long
Private Declare Function ImageList_GetImageCount Lib "comctl32.dll" (ByVal himl As Long) As Long
Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function DrawFocusRect Lib "user32" (ByVal hdc As Long, lpRect As RECT) As Long

Private Declare Function CreatePatternBrush Lib "gdi32" (ByVal hBitmap As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (ByRef Destination As Any, ByVal Length As Long, ByVal Fill As Byte)

Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long
Private Declare Function CreatePen Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpPoint As Long) As Long

Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function LineTo Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As Any, ByVal nCount As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long

Private Const SM_CXVSCROLL                  As Long = 2

Private Type POINTAPI
    x               As Long
    y               As Long
End Type

Private Type SCROLLINFO
    cbSize          As Long
    fMask           As Long
    nMin            As Long
    nMax            As Long
    nPage           As Long
    nPos            As Long
    nTrackPos       As Long
End Type

Private Type RECT
    Left            As Long
    Top             As Long
    Right           As Long
    Bottom          As Long
End Type

Private Const MEM_COMMIT                As Long = &H1000
Private Const PAGE_EXECUTE_READWRITE    As Long = &H40
Private Const MEM_RELEASE               As Long = &H8000&

Private Const WM_MOUSEWHEEL             As Long = &H20A
Private Const WM_VSCROLL                As Long = &H115
Private Const WM_HSCROLL                As Long = &H114
Private Const WM_NCPAINT                As Long = &H85
Private Const WM_DESTROY                As Long = &H2
Private Const WM_NCCALCSIZE             As Long = &H83

Private Const GWL_WNDPROC               As Long = -4
Private Const GWL_STYLE                 As Long = (-16)

Private Const WS_VSCROLL                As Long = &H200000
Private Const WS_HSCROLL                As Long = &H100000

Private Const GW_CHILD                  As Long = 5
Private Const GW_HWNDNEXT               As Long = 2

Private Const SB_HORZ                   As Long = 0
Private Const SB_VERT                   As Long = 1
Private Const SB_BOTH                   As Long = 3
Private Const SB_LINEDOWN               As Long = 1
Private Const SB_LINEUP                 As Long = 0
Private Const SB_PAGEDOWN               As Long = 3
Private Const SB_PAGEUP                 As Long = 2
Private Const SB_THUMBTRACK             As Long = 5
Private Const SB_ENDSCROLL              As Long = 8
Private Const SB_LEFT                   As Long = 6
Private Const SB_RIGHT                  As Long = 7

Private Const SIF_ALL                   As Long = &H17

Private Const SM_CYBORDER               As Long = 6

Public Enum EnuBorderStyle
    vbBSNone
    vbFixedSingle
End Enum

Public Event Resize()
'Public Event Scroll()
'Public Event Paint()
Public Event SelChange(ByVal Index As Long)
Public Event OLEDragDrop(Data As DataObject, IndexPos As Long)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

Private SI                              As SCROLLINFO
Private pASMWrapper                     As Long
Private PrevWndProc                     As Long
Private hSubclassedWnd                  As Long
Private mBorderSize                     As Long
Private OldPosH                         As Long
Private OldPosV                         As Long
Private m_hFocus                        As Long
Private m_AutoScrollToFocus             As Boolean
Private m_UseHandsCursor                As Boolean
Private m_HScrollVisible                As Boolean
Private m_VScrollVisible                As Boolean
Private m_AutoScroll                    As Boolean

Private Const ILD_TRANSPARENT = &H1

Private Type udtItems
    Icon As Long
    Index As Long
End Type

Private tItem() As udtItems
Private lCount As Long
Private m_hImageList As Long
Private m_IconWidth As Long
Private m_IconHeight As Long
Private m_SeletedIndex As Long
Private m_IconPerPage As Long
Private m_BackCheckerBoard As Boolean
Private m_LineDragPos As Long

Public Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    WindowProc = CallWindowProc(PrevWndProc, hwnd, uMsg, wParam, lParam)
    
    Select Case uMsg
        
        Case WM_DESTROY
            Call StopSubclassing

        Case WM_HSCROLL
        
            GetScrollInfo hwnd, SB_HORZ, SI

            Select Case GetLoWord(wParam)
                Case SB_LINEDOWN
                    SI.nPos = SI.nPos + 10
                Case SB_LINEUP
                    SI.nPos = SI.nPos - 10
                Case SB_PAGEDOWN
                    SI.nPos = SI.nPos + SI.nPage
                Case SB_PAGEUP
                    SI.nPos = SI.nPos - SI.nPage
                Case SB_THUMBTRACK
                    SI.nPos = GetHiWord(wParam)
                Case SB_ENDSCROLL
                    '
                Case SB_LEFT
                    SI.nPos = SI.nMin
                Case SB_RIGHT
                    SI.nPos = SI.nMax
            End Select
            
            SetScrollInfo hwnd, SB_HORZ, SI, True
            
            Draw

        Case WM_MOUSEWHEEL
        
            GetScrollInfo hwnd, SB_HORZ, SI
            
            If wParam < 0 Then
                SI.nPos = SI.nPos + 10
            Else
                SI.nPos = SI.nPos - 10
            End If
            
            SetScrollInfo hwnd, SB_HORZ, SI, True
            
            Draw
        Case WM_NCPAINT
        
            If UserControl.BorderStyle = vbFixedSingle Then
                Dim Rec As RECT
                Dim ClipRec As RECT
                Dim hTheme  As Long
                Dim DC As Long
                
                DC = GetWindowDC(UserControl.hwnd)

                GetWindowRect UserControl.hwnd, Rec
                
                Rec.Right = Rec.Right - Rec.Left
                Rec.Bottom = Rec.Bottom - Rec.Top
                Rec.Left = 0
                Rec.Top = 0
                           
                hTheme = OpenThemeData(UserControl.hwnd, StrPtr("Edit"))
                If hTheme Then
                    ExcludeClipRect DC, mBorderSize, mBorderSize, Rec.Right - mBorderSize, Rec.Bottom - mBorderSize
                    If DrawThemeBackGround(hTheme, DC, 0, 0, Rec, Rec) = 0 Then
                    End If
                    Call CloseThemeData(hTheme)
                End If
               
                ReleaseDC hwnd, DC
              
            End If
 
          

    End Select

End Function

Public Sub Remove(ByVal Index As Long)
    Dim BufItem As udtItems
    Dim i As Long

    For i = Index To lCount - 2
        tItem(i).Icon = tItem(i + 1).Icon
    Next
    
    If lCount > 0 Then
        lCount = lCount - 1
        ReDim Preserve tItem(lCount)
    End If
    If m_SeletedIndex > lCount - 1 Then
        m_SeletedIndex = lCount - 1
        RaiseEvent SelChange(m_SeletedIndex)
    End If
    Draw
    'cItem.Remove Index
End Sub

Public Sub Clear()
    'Set cItem = New Collection
    ReDim tItem(0)
    lCount = 0
    m_SeletedIndex = -1
 
    SI.nPage = UserControl.ScaleWidth / Screen.TwipsPerPixelX
    SI.nMax = 0

    SetScrollInfo UserControl.hwnd, SB_HORZ, SI, True

    Me.Refresh
    RaiseEvent SelChange(m_SeletedIndex)
End Sub

Public Property Get ItemCount() As Long
    ItemCount = lCount
End Property

Public Sub AddItem(ByVal iIcon As Long)
    ReDim Preserve tItem(lCount)
    tItem(lCount).Icon = iIcon
    If m_SeletedIndex = -1 Then m_SeletedIndex = 0
    GetScrollInfo UserControl.hwnd, SB_HORZ, SI
    SI.nPage = UserControl.ScaleWidth / Screen.TwipsPerPixelX
    SI.nMax = (m_IconWidth + 8) * (lCount + 1)
    SetScrollInfo hwnd, SB_HORZ, SI, True
    lCount = lCount + 1
    
End Sub

Public Sub InsertItem(ByVal Index As Long, ByVal iIcon As Long)
    Dim i As Long
    
    ReDim Preserve tItem(lCount)
    
    For i = lCount To Index + 1 Step -1
        tItem(i).Icon = tItem(i - 1).Icon
    Next
    
    tItem(Index).Icon = iIcon
    If m_SeletedIndex = -1 Then m_SeletedIndex = 0
    
    GetScrollInfo UserControl.hwnd, SB_HORZ, SI
    SI.nPage = UserControl.ScaleWidth / Screen.TwipsPerPixelX
    SI.nMax = (m_IconWidth + 8) * (lCount + 1)
    SetScrollInfo hwnd, SB_HORZ, SI, True
    lCount = lCount + 1
    
End Sub

Public Property Get IconIndex(ByVal Index As Long) As Long
    IconIndex = tItem(Index).Icon
 
End Property

Public Property Let IconIndex(ByVal Index As Long, ByVal iIcon As Long)
    tItem(Index).Icon = iIcon
    Draw
End Property

Public Property Get ListIndex() As Long
    If m_SeletedIndex > lCount - 1 Then
        ListIndex = -1
    Else
        ListIndex = m_SeletedIndex
    End If
End Property

Public Property Let ListIndex(ByVal Index As Long)
    m_SeletedIndex = Index
    EnfoqueSelection
    Draw
    RaiseEvent SelChange(m_SeletedIndex)
End Property


Public Property Let BackCheckerBoard(ByVal NewValue As Boolean)
    m_BackCheckerBoard = NewValue
    
    If NewValue Then
        CreateCheckerBoard
    Else
        UserControl.Picture = Nothing
    End If
End Property

Private Sub Draw()
    Dim i As Long
    Dim Rec As RECT
    Dim lLeft As Long
    Dim lStar As Long
    Dim lEnd As Long
    UserControl.Cls
    GetScrollInfo UserControl.hwnd, SB_HORZ, SI
    
    lStar = (SI.nPos / (m_IconWidth + 8)) - 1
    If lStar < 0 Then lStar = 0
    
    lEnd = lStar + (SI.nPage / (m_IconWidth + 8)) + 1
    If lEnd > lCount - 1 Then lEnd = lCount - 1
    
    For i = lStar To lEnd
        If i = m_SeletedIndex Then
            lLeft = (i * (m_IconWidth + 8)) - SI.nPos
            'Rectangle UserControl.hdc, lLeft, 0, lLeft + m_IconWidth + 8, UserControl.ScaleHeight / Screen.TwipsPerPixelY
            'DrawSelectionEx UserControl.hdc, lLeft, 0, m_IconWidth + 8, UserControl.ScaleHeight / Screen.TwipsPerPixelY, RGB(249, 253, 255), RGB(234, 247, 255)
            UserControl.Line (lLeft * Screen.TwipsPerPixelY, 0)-((lLeft + m_IconWidth + 8) * Screen.TwipsPerPixelX, UserControl.ScaleHeight), vbHighlight, BF
            Rec.Left = lLeft
            Rec.Bottom = UserControl.ScaleHeight / Screen.TwipsPerPixelY
            Rec.Right = lLeft + m_IconWidth + 9
            DrawFocusRect UserControl.hdc, Rec
        
        End If
        If i = m_LineDragPos Then
            lLeft = ((i * (m_IconWidth + 8)) - SI.nPos) '* Screen.TwipsPerPixelY
            DrawLine UserControl.hdc, lLeft, 0, lLeft, (UserControl.ScaleHeight / Screen.TwipsPerPixelY) - 1
        End If
        Call ImageList_Draw(m_hImageList, tItem(i).Icon, UserControl.hdc, 4 + (i * (m_IconWidth + 8)) - SI.nPos, 8, ILD_TRANSPARENT)
    Next
    UserControl.Refresh
    
End Sub

Public Property Get hImageList() As Long
    hImageList = m_hImageList
End Property

Public Property Let hImageList(ByVal hImgList As Long)
    m_hImageList = hImgList
    ImageList_GetIconSize m_hImageList, m_IconWidth, m_IconHeight
    UserControl.Height = (m_IconHeight + 16 + GetSystemMetrics(SM_CXVSCROLL)) * Screen.TwipsPerPixelY
End Property


Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
    UserControl.BackColor = NewValue
    PropertyChanged "BackColor"
End Property

Public Property Get BorderStyle() As EnuBorderStyle
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal NewValue As EnuBorderStyle)
    UserControl.BorderStyle = NewValue
    PropertyChanged "BorderStyle"
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal Value As Boolean)
    UserControl.Enabled = Value
    PropertyChanged "Enabled"
End Property

Public Sub Refresh()
   GetScrollInfo UserControl.hwnd, SB_HORZ, SI
   SI.nPage = UserControl.ScaleWidth / Screen.TwipsPerPixelX
   m_IconPerPage = SI.nPage \ (m_IconWidth + 8)

   SetScrollInfo UserControl.hwnd, SB_HORZ, SI, True

   If SI.nMax >= SI.nPage Then
        UserControl.Height = (m_IconHeight + 16 + GetSystemMetrics(SM_CXVSCROLL)) * Screen.TwipsPerPixelY
   Else
        UserControl.Height = (m_IconHeight + 16) * Screen.TwipsPerPixelY
   End If
   
   Draw
End Sub



Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    
    Select Case KeyCode
        Case vbKeyLeft
            If m_SeletedIndex > 0 Then
                m_SeletedIndex = m_SeletedIndex - 1
                EnfoqueSelection
                Draw
                RaiseEvent SelChange(m_SeletedIndex)
            End If
        Case vbKeyRight
            If m_SeletedIndex < lCount - 1 Then
                m_SeletedIndex = m_SeletedIndex + 1
                EnfoqueSelection
                Draw
                RaiseEvent SelChange(m_SeletedIndex)
            End If
        Case vbKeyHome
            m_SeletedIndex = 0
            EnfoqueSelection
            Draw
            RaiseEvent SelChange(m_SeletedIndex)
        Case vbKeyEnd
            m_SeletedIndex = lCount - 1
            EnfoqueSelection
            Draw
            RaiseEvent SelChange(m_SeletedIndex)
        Case vbKeyPageUp
            If m_SeletedIndex - m_IconPerPage > 0 Then
                m_SeletedIndex = m_SeletedIndex - m_IconPerPage
            Else
                m_SeletedIndex = 0
            End If
            EnfoqueSelection
            Draw
            RaiseEvent SelChange(m_SeletedIndex)
        Case vbKeyPageDown
            If m_SeletedIndex + m_IconPerPage < lCount - 1 Then
                m_SeletedIndex = m_SeletedIndex + m_IconPerPage
            Else
                m_SeletedIndex = lCount - 1
            End If
            EnfoqueSelection
            Draw
            RaiseEvent SelChange(m_SeletedIndex)
    End Select
    
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub EnfoqueSelection()
    Dim ScrollIndex As Long
    GetScrollInfo UserControl.hwnd, SB_HORZ, SI
    ScrollIndex = SI.nPos \ (m_IconWidth + 8)
    
    
    
    If m_SeletedIndex < ScrollIndex Then
        SI.nPos = (m_IconWidth + 8) * m_SeletedIndex
        SetScrollInfo hwnd, SB_HORZ, SI, True
    Else
        If m_SeletedIndex = ScrollIndex And SI.nPos Mod (m_IconWidth + 8) Then
            SI.nPos = (m_IconWidth + 8) * m_SeletedIndex
            SetScrollInfo hwnd, SB_HORZ, SI, True
        End If
    End If
    

    
    If m_SeletedIndex > ScrollIndex + (SI.nPage \ (m_IconWidth + 8)) Then
        SI.nPos = ((m_IconWidth + 8) * m_SeletedIndex) - (SI.nPage) + (m_IconWidth + 8)
        SetScrollInfo hwnd, SB_HORZ, SI, True
    Else
        If m_SeletedIndex = ScrollIndex + (SI.nPage \ (m_IconWidth + 8)) And (SI.nPos + SI.nPage) Mod (m_IconWidth + 8) Then
            SI.nPos = ((m_IconWidth + 8) * m_SeletedIndex) - (SI.nPage) + (m_IconWidth + 8)
            SetScrollInfo hwnd, SB_HORZ, SI, True
        End If
    End If

End Sub


Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim lPos As Long
    GetScrollInfo UserControl.hwnd, SB_HORZ, SI

    lPos = (x / Screen.TwipsPerPixelX + SI.nPos) \ (m_IconWidth + 8)
    If lPos < lCount Then
        m_SeletedIndex = lPos
        
        EnfoqueSelection

        Draw
        RaiseEvent SelChange(m_SeletedIndex)
    End If
    RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
    RaiseEvent OLEDragDrop(Data, m_LineDragPos)
    m_LineDragPos = -1
    Draw
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
    
    If Data.GetFormat(vbCFFiles) Then
        GetScrollInfo UserControl.hwnd, SB_HORZ, SI
    
        If x > 0 And y > 0 Then
            m_LineDragPos = (x / Screen.TwipsPerPixelX + SI.nPos) \ (m_IconWidth + 8)
            If m_LineDragPos > lCount Then m_LineDragPos = lCount
        Else
            m_LineDragPos = -1
        End If
        Draw
        Effect = 1
    Else
        'Effect = 0
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        Me.BackColor = .ReadProperty("BackColor", vbButtonFace)
        Me.BorderStyle = .ReadProperty("BorderStyle", vbFixedSingle)
        Me.Enabled = .ReadProperty("Enabled", True)

    End With

    If Ambient.UserMode Then
        SetSubclassing UserControl.hwnd
    End If
End Sub

Private Sub UserControl_Resize()

   If m_BackCheckerBoard Then
        CreateCheckerBoard
   End If
   
   Me.Refresh
   RaiseEvent Resize
End Sub


Private Sub CreateCheckerBoard()

    
    Dim hBitmap As Long, mBrush As Long
    Dim PicBits() As Byte
    Dim i As Long
    Dim Rec As RECT
    
    
    UserControl.Cls

    Rec.Right = UserControl.ScaleWidth / Screen.TwipsPerPixelX
    Rec.Bottom = UserControl.ScaleHeight / Screen.TwipsPerPixelY
    
    
    ReDim PicBits(0 To 143) As Byte
    
    FillMemory PicBits(0), 144, 204
    FillMemory PicBits(0), 8, 255
    FillMemory PicBits(15), 8, 255
    FillMemory PicBits(39), 8, 255
    FillMemory PicBits(55), 8, 255
    
    hBitmap = CreateBitmap(4, 4, 1, 32, PicBits(0))

    mBrush = CreatePatternBrush(hBitmap)

    FillRect UserControl.hdc, Rec, mBrush

    DeleteObject mBrush
    DeleteObject hBitmap
    
    UserControl.Picture = UserControl.Image
End Sub


Private Sub UserControl_Show()
    Draw
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "BackColor", UserControl.BackColor, vbButtonFace
        .WriteProperty "BorderStyle", UserControl.BorderStyle, vbFixedSingle
        .WriteProperty "Enabled", UserControl.Enabled, True
    End With
End Sub



' ActiveVB
Private Function SetSubclassing(ByVal hwnd As Long) As Boolean

    'Setzt Subclassing, sofern nicht schon gesetzt
    
    If PrevWndProc = 0 Then
        If pASMWrapper <> 0 Then
            PrevWndProc = SetWindowLong(hwnd, GWL_WNDPROC, pASMWrapper)
            If PrevWndProc <> 0 Then
                hSubclassedWnd = hwnd
                SetSubclassing = True
            End If
        End If
    End If

End Function

' ActiveVB
Private Function StopSubclassing() As Boolean

    'Stopt Subclassing, sofern gesetzt

    If hSubclassedWnd <> 0 Then
        If PrevWndProc <> 0 Then
            Call SetWindowLong(hSubclassedWnd, GWL_WNDPROC, PrevWndProc)
            hSubclassedWnd = 0
            PrevWndProc = 0
            StopSubclassing = True
        End If
    End If

End Function


Private Sub UserControl_Initialize()

    Dim ASM(0 To 104) As Byte
    Dim pVar As Long
    Dim ThisClass As Long
    Dim CallbackFunction As Long
    Dim pVirtualFree
    Dim sCode As String
    Dim i As Long
        
    SI.cbSize = Len(SI)
    SI.fMask = SIF_ALL
    
    mBorderSize = GetSystemMetrics(SM_CYBORDER)
    m_LineDragPos = -1

    pASMWrapper = VirtualAlloc(ByVal 0&, 104, MEM_COMMIT, PAGE_EXECUTE_READWRITE)
    If pASMWrapper <> 0 Then
    

        ThisClass = ObjPtr(Me)
        Call CopyMemory(pVar, ByVal ThisClass, 4)
        Call CopyMemory(CallbackFunction, ByVal (pVar + 1956), 4)

        pVirtualFree = GetProcAddress(GetModuleHandle("kernel32.dll"), "VirtualFree")
        
        sCode = "90FF05000000006A0054FF742418FF742418FF742418FF7424186800000000B800000000FFD0FF0D00000000A10000000085C075" & _
                "0458C21000A10000000085C0740458C2100058595858585868008000006A00680000000051B800000000FFE00000000000000000"
                
        For i = 0 To Len(sCode) - 1 Step 2
            ASM(i / 2) = CByte("&h" & Mid$(sCode, i + 1, 2))
        Next
        
        
        Call CopyMemory(ASM(3), pASMWrapper + 96, 4)
        Call CopyMemory(ASM(40), pASMWrapper + 96, 4)
        Call CopyMemory(ASM(58), pASMWrapper + 96, 4)
        Call CopyMemory(ASM(45), pASMWrapper + 100, 4)
        Call CopyMemory(ASM(84), pASMWrapper, 4)
        Call CopyMemory(ASM(27), ThisClass, 4)
        Call CopyMemory(ASM(32), CallbackFunction, 4)
        Call CopyMemory(ASM(90), pVirtualFree, 4)
        Call CopyMemory(ByVal pASMWrapper, ASM(0), 104)
    End If
End Sub

Private Function GetLoWord(dw As Long) As Long
    If dw And &H8000& Then
       GetLoWord = &H8000 Or (dw And &H7FFF&)
    Else
       GetLoWord = dw And &HFFFF&
    End If
End Function

Private Function GetHiWord(dw As Long) As Long
    If dw And &H80000000 Then
       GetHiWord = (dw \ 65535) - 1
    Else
       GetHiWord = dw \ 65535
    End If
End Function



Private Sub UserControl_Terminate()
    Dim Counter As Long
    Dim Flag As Long

    If pASMWrapper <> 0 Then
        Call StopSubclassing
        
        Call CopyMemory(Counter, ByVal (pASMWrapper + 104), 4)
        
        If Counter = 0 Then
            Call VirtualFree(ByVal pASMWrapper, 0, MEM_RELEASE)
        Else
            Flag = 1
            Call CopyMemory(ByVal (pASMWrapper + 108), Flag, 4)
        End If
        
    End If

End Sub


Public Sub DrawLine(ByVal hdc As Long, _
                    ByVal X1 As Long, _
                    ByVal Y1 As Long, _
                    ByVal X2 As Long, _
                    ByVal Y2 As Long, _
                    Optional ByVal Color As Long = -1, _
                    Optional ByVal BorderWidth As Long = 1)
 
    Dim hPen As Long
    Dim hBrush As Long
    Dim TransColor As Long
    Dim OldPen As Long
    Dim OldBrush As Long
    Dim pt(2) As POINTAPI
 
    If Color <> -1 Then
        Call OleTranslateColor(Color, 0&, TransColor)
        hPen = CreatePen(0, BorderWidth, TransColor)
        OldPen = SelectObject(hdc, hPen)
        hBrush = CreateSolidBrush(Color)
        OldBrush = SelectObject(hdc, hBrush)
    End If
 
    If X1 >= 0 Then
        MoveToEx hdc, X1, Y1, 0
    End If
 
    LineTo hdc, X2, Y2
    
    pt(0).x = X1 - 3:      pt(0).y = Y1
    pt(1).x = X1:        pt(1).y = Y1 + 3
    pt(2).x = X1 + 3:     pt(2).y = Y1
    
    Polygon hdc, pt(0), 3
    
    pt(0).x = X2 - 3:     pt(0).y = Y2
    pt(1).x = X2:    pt(1).y = Y2 - 3
    pt(2).x = X2 + 3:      pt(2).y = Y2
    
    Polygon hdc, pt(0), 3
    
    If Color <> -1 Then
        DeleteObject SelectObject(hdc, OldPen)
        DeleteObject SelectObject(hdc, OldBrush)
    End If
 
End Sub

